#include "showsort.h"

extern int n;
extern int x[MAXITEMS];
extern int col[MAXITEMS];
extern int sort_direction;
extern int delay;

state_type current;
extern int list_used;

int bubble_sort_step()
{
  int tmp;

  switch (current.state) {

    case STATE_BEGIN :
      list_used = TRUE;
      current.state = STATE_COMPARE;
      current.list_left = 0;
      current.list_right = n - 1;
      if (sort_direction == SORT_REVERSE) {
        current.direction = SORT_REVERSE;
        current.item1 = n - 2;
        current.item2 = n - 1;
	current.last_swap = n - 2; /* check this again */
      }
      else {
        current.direction = SORT_FORWARD;
        current.item1 = 0;
        current.item2 = 1;
	current.last_swap = 0; /* check this again */
      }
      col[current.item1] = COLOR_COMPARE;
      col[current.item2] = COLOR_COMPARE;
      update_pic(current.item1, current.item2);
      break;

    case STATE_COMPARE:
      if (x[current.item1] > x[current.item2]) {
	current.state = STATE_SWAP;
	SWAP(x[current.item1], x[current.item2])
        col[current.item1] = COLOR_SWAP;
        col[current.item2] = COLOR_SWAP;
        update_pic(current.item1, current.item2);
	current.last_swap = current.item1;
      }
      else {
	if (current.direction == SORT_FORWARD) {
	  if (current.item2 == current.list_right){
            current.state = STATE_FINISH_LINE;
	    return (bubble_sort_step());
	  }
	  else {
            col[current.item1] = COLOR_NORMAL;
	    current.item2++;
            col[current.item2] = COLOR_COMPARE;
            update_pic(current.item1, current.item2);
	    current.item1++;
	  }
	}
	else {
	  if (current.item1 == current.list_left){
            current.state = STATE_FINISH_LINE;
	    return (bubble_sort_step());
	  }
	  else {
            col[current.item2] = COLOR_NORMAL;
	    current.item1--;
            col[current.item1] = COLOR_COMPARE;
            update_pic(current.item1, current.item2);
	    current.item2--;
	  }
	}
      }
      break;

    case STATE_SWAP :
      if (current.direction == SORT_FORWARD) {
	if (current.item2 == current.list_right){
          current.state = STATE_FINISH_LINE;
	    return (bubble_sort_step());
	}
	else {
          col[current.item1] = COLOR_NORMAL;
          col[current.item2] = COLOR_COMPARE;
          current.item2++;
          col[current.item2] = COLOR_COMPARE;
          update_pic(current.item1, current.item2);
	  current.item1++;
	  current.state = STATE_COMPARE;
	}
      }
      else {
	if (current.item1 == current.list_left){
          current.state = STATE_FINISH_LINE;
	    return (bubble_sort_step());
	}
	else {
          col[current.item2] = COLOR_NORMAL;
          col[current.item1] = COLOR_COMPARE;
          current.item1--;
          col[current.item1] = COLOR_COMPARE;
          update_pic(current.item1, current.item2);
          current.item2--;
	  current.state = STATE_COMPARE;
	}
      }
      break;

    case STATE_FINISH_LINE :
      if (current.direction == SORT_FORWARD) {
	col[current.item1] = COLOR_NORMAL;
	col[current.item2] = COLOR_SORTED;
	current.list_right--;
	if (sort_direction != SORT_FORWARD)
	  current.direction = SORT_REVERSE;
      }
      else {
	col[current.item1] = COLOR_SORTED;
	col[current.item2] = COLOR_NORMAL;
	current.list_left++;
	if (sort_direction != SORT_REVERSE)
	  current.direction = SORT_FORWARD;
      }
      if (current.list_left == current.list_right){
	col[current.item1] = COLOR_SORTED;
	col[current.item2] = COLOR_SORTED;
        update_pic(current.item1, current.item2);
	update_progress(1.0);
	current.state = STATE_FINISHED;
	break;
      }
      update_pic(current.item1, current.item2);
      update_progress((n - (current.list_right - current.list_left + 1)) / (float)n);
      current.state = STATE_FINISHED_LINE;
      break;

    case STATE_FINISHED_LINE:
      /* add last_swap here later */
      if (current.direction == SORT_FORWARD) {
	current.item1 = current.list_left;
	current.item2 = current.list_left + 1;
      }
      else {
	current.item1 = current.list_right - 1;
	current.item2 = current.list_right;
      }
      current.state = STATE_COMPARE;
      col[current.item1] = COLOR_COMPARE;
      col[current.item2] = COLOR_COMPARE;
      update_pic(current.item1, current.item2);
      break;

    case STATE_FINISHED :
      return TRUE;
      break;
  }
  return FALSE;
}

