/**********************************************************************/

/* include files */

#include <gtk/gtk.h>

#include <time.h>
#include <stdlib.h>
#include <unistd.h>

/**********************************************************************/

/* constant definitions */

/* maximum number of iterations */
#define MAXITEMS 200

/* sort types */
#define SELECTION_SORT  1
#define INSERTION_SORT  2
#define BUBBLE_SORT     3
#define QUICK_SORT      4

/* initial list types */
#define SORTED          1
#define REVERSE         2
#define RANDOM          3
#define ALMOST_SORTED   4
#define ALMOST_REVERSE  5

/* data limits */
#define DATAMAX  150
#define DATAMIN   50

/* sort directions */
#define SORT_FORWARD         1
#define SORT_REVERSE         2
#define SORT_BI_DIRECTIONAL  3

/* states of a sorting process */
#define STATE_BEGIN          1
#define STATE_FINISHED       2
#define STATE_COMPARE        3
#define STATE_TAKE           4
#define STATE_SWAP           5
#define STATE_FINISH_LINE    6
#define STATE_FINISHED_LINE  7

/* box color codes */
/* Should start from 0 and go continuously */
#define COLOR_NORMAL   0
#define COLOR_IGNORED  1
#define COLOR_COMPARE  2
#define COLOR_TAKE     3
#define COLOR_SWAP     4
#define COLOR_SORTED   5
#define BAR_COLORS     6

/**********************************************************************/

/* macro definitions */

/* a swap macro - availability of tmp variable is assumed */
#define SWAP(a,b) {tmp=a;a=b;b=tmp;}

/**********************************************************************/

/* type declaratons */

/* current state type */
typedef struct {
  int state;
  int direction;
  int list_left;
  int list_right;
  int item1;
  int item2;
  int last_swap;
} state_type;

/**********************************************************************/

/* prototypes */

/* routine to create the main window */
void main_window ();

/* parts of the main window */
GtkWidget *create_menu_bar (GtkWidget *windoclickedw);
GtkWidget *create_tool_bar ();

/* callbacks of the main window */
gint delete_event (GtkWidget *widget, GdkEvent *event, gpointer data);
void destroy (GtkWidget *widget, gpointer data);

/* functions related to the drawing area pixmap */
gint expose_event (GtkWidget *widget, GdkEventExpose *event);
gint configure_event (GtkWidget *widget, GdkEventConfigure *event);

/* routines to handle toolbar events */
void change_sort_type (GtkWidget *widget, gpointer data);
void change_list_type (GtkWidget *widget, gpointer data);

/* routines to handle user buttons */
void reset_list (GtkWidget *widget, gpointer data);
void start_play (GtkWidget *widget, gpointer data);
void step_play (GtkWidget *widget, gpointer data);

void set_direction (GtkWidget *widget, gpointer data);

void update_pic (int n1, int n2);
void update_progress(gfloat percentage);

/* sort routines */
int bubble_sort_step ();

/**********************************************************************/
